/*
 * yasapi_defines.h
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __YASAPI_DEFINES_H__ // [
#define __YASAPI_DEFINES_H__

#ifdef __cplusplus // [
extern "C" {
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#if ! defined (YASAPI_MAJOR) // [
#define YASAPI_MAJOR 0
#endif // ]

#if ! defined (YASAPI_MINOR) // [
#define YASAPI_MINOR 0
#endif // ]

#if ! defined (YASAPI_BUILD) // [
#define YASAPI_BUILD 0
#endif // ]

#if ! defined (YASAPI_BETA) // [
#define YASAPI_BETA 0
#endif // ]

#define YASAPI_MIN_VERSION(major,minor,beta) ( \
  ((major)<YASAPI_MAJOR) || ((major)==(YASAPI_MAJOR)) && ( \
    ((minor)<YASAPI_MINOR) || ((minor)==(YASAPI_MINOR)) && ( \
      0==(YASAPI_BETA) || (beta)<=(YASAPI_BETA) \
    ) \
  ) \
)

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_DEBUG) // [
//#define YASAPI_DEBUG_PROPERTY
//#define YASAPI_DEBUG_CONFIG
#endif // ]
//#define YASAPI_ABOUT_TEXT_VIEW
#define YASAPI_DEVICE_MARKUP
//#define YASAPI_ENGINE_REGISTER_WHEN_STARING
//#define YASAPI_PRODUCTBUILD
//#define YASAPI_PLAYBACK_BEGIN_MIN_NUM_CHUNKS

#if defined (_MSC_VER) // [
//#define YASAPI_FILE_OPEN_DIALOG
#endif // ]

#define YASAPI_RING1

#if ! defined (YASAPI_DEBUG) // [
#define YASAPI_AV_THREAD_CHARACTERISTICS
#endif // ]

#if YASAPI_MIN_VERSION(2,1,6) // [
#define YASAPI_TIME
#endif // ]

#if 0 // [
#if YASAPI_MIN_VERSION(2,1,0) // [
#define YASAPI_MERKEL_IST_WEG
#endif // ]

#if 2==(YASAPI_MAJOR)&& 1==(YASAPI_MINOR)&&0==(YASAPI_BETA) // [
#define YASAPI_MERKEL_IST_WEG_EDITION
#endif // ]
#endif // ]

#if YASAPI_MIN_VERSION(2,2,1) // [
#if defined (YASAPI_RING1) // [
#undef YASAPI_RING1
#endif // ]
#define YASAPI_RING2
#endif // ]

#if defined (YASAPI_RING2) // [
#define YASAPI_CONTROL_START
#define YASAPI_RING_REALLOC
#define YASAPI_NO_OPTION_RING_SIZE
//#define YASAPI_PREPEND_SILENCE
#endif // ]

#if YASAPI_MIN_VERSION(2,2,2) // [
#define YASAPI_OPTION_GAPLESS
#endif // ]

#if YASAPI_MIN_VERSION(2,3,1) // [
#define YASAPI_API
#endif // ]

#if defined (_MSC_VER) // [
///////////////////////////////////////////////////////////////////////////////
#define __func__ __FUNCTION__
#endif // ]

///////////////////////////////////////////////////////////////////////////////
// https://gustedt.wordpress.com/2010/06/16/associativity-of-double-constants-and-preprocessor-tokens/
#define YASAPI_PASTE2(a, b) \
  a ## b
#define _YASAPI_PASTE2(a, b) \
  YASAPI_PASTE2(a, b)
#define YASAPI_PASTE3(a, b, c) \
  _YASAPI_PASTE2(YASAPI_PASTE2(a, b), c)
#define YASAPI_PASTE4(a, b, c, d) \
  _YASAPI_PASTE2(YASAPI_PASTE3(a, b, c), d)
#define YASAPI_PASTE5(a, b, c, d, e) \
  _YASAPI_PASTE2(YASAPI_PASTE4(a, b, c, d), e)
#define YASAPI_PASTE6(a, b, c, d, e, f) \
  _YASAPI_PASTE2(YASAPI_PASTE5(a, b, c, d, e), f)

#define _YASAPI_STRA(id) \
    #id
#define YASAPI_STRA(id) \
    _YASAPI_STRA(id)
#define _YASAPI_STRW(id) \
    L ## #id
#define YASAPI_STRW(id) \
    _YASAPI_STRW(id)

#define YASAPI_ARRAYSIZE(a) \
    (sizeof (a))/(sizeof (a)[0])

///////////////////////////////////////////////////////////////////////////////
#define YASAPI_VERSION \
    YASAPI_PASTE5(YASAPI_MAJOR,.,YASAPI_MINOR,.,YASAPI_BUILD)

#if defined (YASAPI_DEBUG) // [
#if defined (__GNUC__) // [
#define YASAPI_TITLE_SFX " (debug" YASAPI_STRA(YASAPI_DEBUG) "/gcc)"
#define YASAPI_TITLE_SFX_U8 " (debug" YASAPI_STRA(YASAPI_DEBUG) "/gcc)"
#define YASAPI_TITLE_SFX_U16 L" (debug" YASAPI_STRW(YASAPI_DEBUG) L"/gcc)"
#elif defined (_MSC_VER) // ] [
#define YASAPI_TITLE_SFX " (debug" YASAPI_STRA(YASAPI_DEBUG) "/msc)"
#define YASAPI_TITLE_SFX_U8 " (debug" YASAPI_STRA(YASAPI_DEBUG) "/msc)"
#define YASAPI_TITLE_SFX_U16 L" (debug" YASAPI_STRW(YASAPI_DEBUG) L"/msc)"
#else // ] [
#define YASAPI_TITLE_SFX "(debug" YASAPI_STRA(YASAPI_DEBUG) ")"
#define YASAPI_TITLE_SFX_U8 "(debug" YASAPI_STRA(YASAPI_DEBUG) ")"
#define YASAPI_TITLE_SFX_U16 L"(debug" YASAPI_STRW(YASAPI_DEBUG) L")"
#endif // ]
#else // ] [
#if defined (__GNUC__) // [
#define YASAPI_TITLE_SFX " (gcc)"
#define YASAPI_TITLE_SFX_U8 " (gcc)"
#define YASAPI_TITLE_SFX_U16 L" (gcc)"
#elif defined (_MSC_VER) // ] [
#define YASAPI_TITLE_SFX " (msc)"
#define YASAPI_TITLE_SFX_U8 " (msc)"
#define YASAPI_TITLE_SFX_U16 L" (msc)"
#else // ] [
#define YASAPI_TITLE_SFX ""
#define YASAPI_TITLE_SFX_U8 ""
#define YASAPI_TITLE_SFX_U16 L""
#endif // ]
#endif // ]

#if defined (YASAPI_BETA) && 0<YASAPI_BETA // [
#define YASAPI_VERSION_SFX "-beta" YASAPI_STRA(YASAPI_BETA)
#define YASAPI_VERSION_SFX_U8 "-\316\262" YASAPI_STRA(YASAPI_BETA)
#define YASAPI_VERSION_SFX_U16 L"-\x03B2" YASAPI_STRW(YASAPI_BETA)
#else // ] [
#define YASAPI_VERSION_SFX ""
#define YASAPI_VERSION_SFX_U8 ""
#define YASAPI_VERSION_SFX_U16 L""
#endif // ]

#define YASAPI_VERSION_CS YASAPI_STRA(YASAPI_VERSION) YASAPI_VERSION_SFX
#define YASAPI_VERSION_U8 YASAPI_STRA(YASAPI_VERSION) YASAPI_VERSION_SFX_U8
#define YASAPI_VERSION_U16 YASAPI_STRW(YASAPI_VERSION) YASAPI_VERSION_SFX_U16

#if defined (YASAPI_MERKEL_IST_WEG_EDITION) // [
#define YASAPI_TITLE "YASAPI/NT Output v" YASAPI_VERSION_CS \
    " MERKEL IST WEG! " YASAPI_TITLE_SFX
#define YASAPI_TITLE_U8 "YASAPI/NT Output v" YASAPI_VERSION_U8 \
    " MERKEL IST WEG! " YASAPI_TITLE_SFX_U8
#define YASAPI_TITLE_U16 L"YASAPI/NT Output v" YASAPI_VERSION_U16 \
    L" MERKEL IST WEG! " YASAPI_TITLE_SFX_U16
#else // ] [
#define YASAPI_TITLE "YASAPI/NT Output v" YASAPI_VERSION_CS \
    YASAPI_TITLE_SFX
#define YASAPI_TITLE_U8 "YASAPI/NT Output v" YASAPI_VERSION_U8 \
    YASAPI_TITLE_SFX_U8
#define YASAPI_TITLE_U16 L"YASAPI/NT Output v" YASAPI_VERSION_U16 \
    YASAPI_TITLE_SFX_U16
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#define DMESSAGE(format) \
    yasapi_message(__FILE__,__LINE__,format,0ul)
#define DVMESSAGE(format,...) \
    yasapi_message(__FILE__,__LINE__,format,0ul,__VA_ARGS__)

#define DCMESSAGE(m,label) case label: \
    DMESSAGE(m " failed with " #label); \
    break
#define DVCMESSAGE(m,label,...) case label: \
    DVMESSAGE(m " failed with " #label,__VA_ARGS__); \
    break
#define DDMESSAGE(m,hr) default: \
    DVMESSAGE(m " failed with unknown %p",hr); \
    break
#define DVDMESSAGE(m,hr,...) default: \
    DVMESSAGE(m " failed with unknown %p",__VA_ARGS__,hr); \
    break

#if 0 || defined (YASAPI_DEBUG) // [
#define DASSERT(condition,label) do { \
  if (!(condition)) { \
    DMESSAGE(YASAPI_STRA(condition) " does not hold"); \
    goto label; \
  } \
} while (0)

#define DASSERT_ENGINE_STATE(pEngine,_eState,label) do { \
  if ((pEngine)->eState!=_eState) { \
    DVMESSAGE("%s==%s does not hold",EngineState(pEngine), \
        EngineStateEx(_eState)); \
    goto label; \
  } \
} while (0)

#define DEXIT() \
  exit:
#else // ] [
#define DASSERT(condition,label)
#define DASSERT_ENGINE_STATE(pEngine,_eState,label)
#define DEXIT()
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_DEBUG) // [
#define DMARKLN() \
  TraceMarkLn(__FILE__,__LINE__,__func__)
#define DWRITELN(line) \
  TraceWriteLn(__FILE__,__LINE__,__func__,line)
#define DWRITELNW(line) \
  TraceWriteLnW(__FILE__,__LINE__,__func__,line)
#define DVWRITELN(format,...) \
  TraceVWriteLn(__FILE__,__LINE__,__func__,format,__VA_ARGS__)
#define DVWRITELNW(format,...) \
  TraceVWriteLnW(__FILE__,__LINE__,__func__,format,__VA_ARGS__)
#define DSLEEP(ms) \
  Sleep(ms)
#define DGETC() \
  fgetc(stdin)
#else // ] [
#define DMARKLN()
#define DWRITELN(s)
#define DWRITELNW(s)
#define DVWRITELN(format,...)
#define DVWRITELNW(format,...)
#define DGETC()
#define DSLEEP(ms)
#endif // ]

///////////////////////////////////////////////////////////////////////////////
/*
// http://blog.differentpla.net/blog/2008/10/25/things-i-learnt-this-week-setwaitabletimer
#define YASAPI_UNITS_PER_MICROSECOND 10
#define YASAPI_UNITS_PER_MILLISECOND = YASAPI_UNITS_PER_MICROSECOND * 1000
#define YASAPI_UNITS_PER_SECOND = YASAPI_UNITS_PER_MILLISECOND * 1000
*/

#define YASAPI_MS2FRAMES(ms,pwfx) \
  ((ms)*(pwfx)->Format.nSamplesPerSec/1000.0)
#define YASAPI_FRAMES2MS(uNumFrames,pwfx) \
  (1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_FRAMES2HNS(uNumFrames,pwfx) \
  (10.0*1000.0*1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_SIZE2FRAMES(dwSize,pwfx) \
  MulDiv(1,dwSize,(pwfx)->Format.nBlockAlign)

#ifdef __cplusplus // [
}
#endif // ]
#endif // __YASAPI_DEFINES_H__ ]
